local gui = require('Gspot')()
local cam11 = require('cam11')()
local pressed = love.keyboard.isScancodeDown
local speed = 100
local px = 250
local py = 250
local map
local plr
local button1
local button2
local pos1x, pos1y = 544, 114  -- image coordinates where to place the button
local pos2x, pos2y = 576, 208  -- ditto

local function butclick(self)
  self.data = (self.data or 0) + 1
  self.label = "Clicked " .. self.data .. " times"
end

function love.load(args)
  button1 = gui:button("Wermin", {128, 128, 128, 16})
  button2 = gui:button("Garrt", {128, 128, 128, 16})
  button1.click = butclick
  button2.click = butclick
  map = love.graphics.newImage('map.jpg')
  plr = love.graphics.newImage('player.png')
end

function love.keypressed(key, code, isrepeat)
  if key == 'escape' then return love.event.quit() end
  gui:keypress(key)
end

function love.textinput(text)
  gui:textinput(text)
end

function love.mousepressed(x, y, button)
  gui:mousepress(x, y, button)
end

function love.mousereleased(x, y, button)
  gui:mouserelease(x, y, button)
end

function love.wheelmoved(x, y)
  gui:mousewheel(x, y)
end

function love.update(dt)
  gui:update(dt)
  if pressed('a', 'left') then
    px = px - speed * dt
  end
  if pressed('d', 'right') then
    px = px + speed * dt
  end
  if pressed('w', 'up') then
    py = py - speed * dt
  end
  if pressed('s', 'down') then
    py = py + speed * dt
  end
  cam11:setPos(px, py)

  -- Update the button positions
  local x, y
  x, y = cam11:toScreen(pos1x, pos1y)
  button1.pos.x, button1.pos.y = x - button1.pos.w / 2, y
  x, y = cam11:toScreen(pos2x, pos2y)
  button2.pos.x, button2.pos.y = x - button2.pos.w / 2, y
end

function love.draw()
  cam11:attach()

  love.graphics.draw(map)
  love.graphics.draw(plr, px, py, 0, .25, .25, plr:getWidth()/2, plr:getHeight()/2)

  cam11:detach()

  -- Draw the GUI without the camera.
  gui:draw()
end
